Index: trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginView.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginView.Designer.cs	(revision 3006)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginView.Designer.cs	(revision 3006)
@@ -0,0 +1,314 @@
+﻿namespace HeuristicLab.PluginInfrastructure.Advanced {
+  partial class PluginView {
+    /// <summary> 
+    /// Required designer variable.
+    /// </summary>
+    private System.ComponentModel.IContainer components = null;
+
+    /// <summary> 
+    /// Clean up any resources being used.
+    /// </summary>
+    /// <param name="disposing">true if managed resources should be disposed; otherwise, false.</param>
+    protected override void Dispose(bool disposing) {
+      if (disposing && (components != null)) {
+        components.Dispose();
+      }
+      base.Dispose(disposing);
+    }
+
+    #region Component Designer generated code
+
+    /// <summary> 
+    /// Required method for Designer support - do not modify 
+    /// the contents of this method with the code editor.
+    /// </summary>
+    private void InitializeComponent() {
+      this.components = new System.ComponentModel.Container();
+      this.nameLabel = new System.Windows.Forms.Label();
+      this.nameTextBox = new System.Windows.Forms.TextBox();
+      this.versionTextBox = new System.Windows.Forms.TextBox();
+      this.versionLabel = new System.Windows.Forms.Label();
+      this.contactTextBox = new System.Windows.Forms.TextBox();
+      this.contactInfoLabel = new System.Windows.Forms.Label();
+      this.licenseButton = new System.Windows.Forms.Button();
+      this.dependenciesGroupBox = new System.Windows.Forms.GroupBox();
+      this.dependenciesListView = new System.Windows.Forms.ListView();
+      this.pluginNameHeader = new System.Windows.Forms.ColumnHeader();
+      this.pluginVersionHeader = new System.Windows.Forms.ColumnHeader();
+      this.imageList = new System.Windows.Forms.ImageList(this.components);
+      this.filesListView = new System.Windows.Forms.ListView();
+      this.fileNameHeader = new System.Windows.Forms.ColumnHeader();
+      this.fileTypeHeader = new System.Windows.Forms.ColumnHeader();
+      this.filesGroupBox = new System.Windows.Forms.GroupBox();
+      this.stateTextBox = new System.Windows.Forms.TextBox();
+      this.stateLabel = new System.Windows.Forms.Label();
+      this.errorLabel = new System.Windows.Forms.Label();
+      this.descriptionLabel = new System.Windows.Forms.Label();
+      this.errorTextBox = new System.Windows.Forms.RichTextBox();
+      this.descriptionTextBox = new System.Windows.Forms.RichTextBox();
+      this.dependenciesGroupBox.SuspendLayout();
+      this.filesGroupBox.SuspendLayout();
+      this.SuspendLayout();
+      // 
+      // nameLabel
+      // 
+      this.nameLabel.AutoSize = true;
+      this.nameLabel.Location = new System.Drawing.Point(3, 6);
+      this.nameLabel.Name = "nameLabel";
+      this.nameLabel.Size = new System.Drawing.Size(38, 13);
+      this.nameLabel.TabIndex = 0;
+      this.nameLabel.Text = "Name:";
+      // 
+      // nameTextBox
+      // 
+      this.nameTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.nameTextBox.Location = new System.Drawing.Point(74, 3);
+      this.nameTextBox.Name = "nameTextBox";
+      this.nameTextBox.ReadOnly = true;
+      this.nameTextBox.Size = new System.Drawing.Size(269, 20);
+      this.nameTextBox.TabIndex = 1;
+      // 
+      // versionTextBox
+      // 
+      this.versionTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.versionTextBox.Location = new System.Drawing.Point(74, 29);
+      this.versionTextBox.Name = "versionTextBox";
+      this.versionTextBox.ReadOnly = true;
+      this.versionTextBox.Size = new System.Drawing.Size(269, 20);
+      this.versionTextBox.TabIndex = 3;
+      // 
+      // versionLabel
+      // 
+      this.versionLabel.AutoSize = true;
+      this.versionLabel.Location = new System.Drawing.Point(3, 32);
+      this.versionLabel.Name = "versionLabel";
+      this.versionLabel.Size = new System.Drawing.Size(45, 13);
+      this.versionLabel.TabIndex = 2;
+      this.versionLabel.Text = "Version:";
+      // 
+      // contactTextBox
+      // 
+      this.contactTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.contactTextBox.Location = new System.Drawing.Point(74, 55);
+      this.contactTextBox.Name = "contactTextBox";
+      this.contactTextBox.ReadOnly = true;
+      this.contactTextBox.Size = new System.Drawing.Size(269, 20);
+      this.contactTextBox.TabIndex = 5;
+      // 
+      // contactInfoLabel
+      // 
+      this.contactInfoLabel.AutoSize = true;
+      this.contactInfoLabel.Location = new System.Drawing.Point(3, 58);
+      this.contactInfoLabel.Name = "contactInfoLabel";
+      this.contactInfoLabel.Size = new System.Drawing.Size(47, 13);
+      this.contactInfoLabel.TabIndex = 4;
+      this.contactInfoLabel.Text = "Contact:";
+      // 
+      // licenseButton
+      // 
+      this.licenseButton.Anchor = ((System.Windows.Forms.AnchorStyles)((System.Windows.Forms.AnchorStyles.Bottom | System.Windows.Forms.AnchorStyles.Left)));
+      this.licenseButton.Location = new System.Drawing.Point(3, 586);
+      this.licenseButton.Name = "licenseButton";
+      this.licenseButton.Size = new System.Drawing.Size(103, 23);
+      this.licenseButton.TabIndex = 10;
+      this.licenseButton.Text = "Show license";
+      this.licenseButton.UseVisualStyleBackColor = true;
+      this.licenseButton.Click += new System.EventHandler(this.licenseButton_Click);
+      // 
+      // dependenciesGroupBox
+      // 
+      this.dependenciesGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)((((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Bottom)
+                  | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.dependenciesGroupBox.Controls.Add(this.dependenciesListView);
+      this.dependenciesGroupBox.Location = new System.Drawing.Point(6, 408);
+      this.dependenciesGroupBox.Name = "dependenciesGroupBox";
+      this.dependenciesGroupBox.Size = new System.Drawing.Size(340, 172);
+      this.dependenciesGroupBox.TabIndex = 1;
+      this.dependenciesGroupBox.TabStop = false;
+      this.dependenciesGroupBox.Text = "Dependencies";
+      // 
+      // dependenciesListView
+      // 
+      this.dependenciesListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
+            this.pluginNameHeader,
+            this.pluginVersionHeader});
+      this.dependenciesListView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.dependenciesListView.Location = new System.Drawing.Point(3, 16);
+      this.dependenciesListView.Name = "dependenciesListView";
+      this.dependenciesListView.Size = new System.Drawing.Size(334, 153);
+      this.dependenciesListView.SmallImageList = this.imageList;
+      this.dependenciesListView.TabIndex = 0;
+      this.dependenciesListView.UseCompatibleStateImageBehavior = false;
+      this.dependenciesListView.View = System.Windows.Forms.View.Details;
+      this.dependenciesListView.ItemActivate += new System.EventHandler(this.dependenciesListView_ItemActivate);
+      // 
+      // pluginNameHeader
+      // 
+      this.pluginNameHeader.Text = "Name";
+      this.pluginNameHeader.Width = 200;
+      // 
+      // pluginVersionHeader
+      // 
+      this.pluginVersionHeader.Text = "Version";
+      this.pluginVersionHeader.Width = 120;
+      // 
+      // imageList
+      // 
+      this.imageList.ColorDepth = System.Windows.Forms.ColorDepth.Depth8Bit;
+      this.imageList.ImageSize = new System.Drawing.Size(16, 16);
+      this.imageList.TransparentColor = System.Drawing.Color.Transparent;
+      // 
+      // filesListView
+      // 
+      this.filesListView.Columns.AddRange(new System.Windows.Forms.ColumnHeader[] {
+            this.fileNameHeader,
+            this.fileTypeHeader});
+      this.filesListView.Dock = System.Windows.Forms.DockStyle.Fill;
+      this.filesListView.Location = new System.Drawing.Point(3, 16);
+      this.filesListView.Name = "filesListView";
+      this.filesListView.Size = new System.Drawing.Size(331, 140);
+      this.filesListView.SmallImageList = this.imageList;
+      this.filesListView.TabIndex = 0;
+      this.filesListView.UseCompatibleStateImageBehavior = false;
+      this.filesListView.View = System.Windows.Forms.View.Details;
+      // 
+      // fileNameHeader
+      // 
+      this.fileNameHeader.Text = "Name";
+      this.fileNameHeader.Width = 200;
+      // 
+      // fileTypeHeader
+      // 
+      this.fileTypeHeader.Text = "Type";
+      this.fileTypeHeader.Width = 120;
+      // 
+      // filesGroupBox
+      // 
+      this.filesGroupBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.filesGroupBox.Controls.Add(this.filesListView);
+      this.filesGroupBox.Location = new System.Drawing.Point(9, 243);
+      this.filesGroupBox.Name = "filesGroupBox";
+      this.filesGroupBox.Size = new System.Drawing.Size(337, 159);
+      this.filesGroupBox.TabIndex = 11;
+      this.filesGroupBox.TabStop = false;
+      this.filesGroupBox.Text = "Files";
+      // 
+      // stateTextBox
+      // 
+      this.stateTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.stateTextBox.Location = new System.Drawing.Point(74, 145);
+      this.stateTextBox.Name = "stateTextBox";
+      this.stateTextBox.ReadOnly = true;
+      this.stateTextBox.Size = new System.Drawing.Size(269, 20);
+      this.stateTextBox.TabIndex = 13;
+      // 
+      // stateLabel
+      // 
+      this.stateLabel.AutoSize = true;
+      this.stateLabel.Location = new System.Drawing.Point(3, 148);
+      this.stateLabel.Name = "stateLabel";
+      this.stateLabel.Size = new System.Drawing.Size(35, 13);
+      this.stateLabel.TabIndex = 12;
+      this.stateLabel.Text = "State:";
+      // 
+      // errorLabel
+      // 
+      this.errorLabel.AutoSize = true;
+      this.errorLabel.Location = new System.Drawing.Point(3, 174);
+      this.errorLabel.Name = "errorLabel";
+      this.errorLabel.Size = new System.Drawing.Size(32, 13);
+      this.errorLabel.TabIndex = 15;
+      this.errorLabel.Text = "Error:";
+      // 
+      // descriptionLabel
+      // 
+      this.descriptionLabel.AutoSize = true;
+      this.descriptionLabel.Location = new System.Drawing.Point(3, 84);
+      this.descriptionLabel.Name = "descriptionLabel";
+      this.descriptionLabel.Size = new System.Drawing.Size(63, 13);
+      this.descriptionLabel.TabIndex = 17;
+      this.descriptionLabel.Text = "Description:";
+      // 
+      // errorTextBox
+      // 
+      this.errorTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.errorTextBox.Location = new System.Drawing.Point(74, 171);
+      this.errorTextBox.Name = "errorTextBox";
+      this.errorTextBox.ReadOnly = true;
+      this.errorTextBox.Size = new System.Drawing.Size(269, 66);
+      this.errorTextBox.TabIndex = 18;
+      this.errorTextBox.Text = "";
+      // 
+      // descriptionTextBox
+      // 
+      this.descriptionTextBox.Anchor = ((System.Windows.Forms.AnchorStyles)(((System.Windows.Forms.AnchorStyles.Top | System.Windows.Forms.AnchorStyles.Left)
+                  | System.Windows.Forms.AnchorStyles.Right)));
+      this.descriptionTextBox.Location = new System.Drawing.Point(74, 81);
+      this.descriptionTextBox.Name = "descriptionTextBox";
+      this.descriptionTextBox.ReadOnly = true;
+      this.descriptionTextBox.Size = new System.Drawing.Size(269, 58);
+      this.descriptionTextBox.TabIndex = 19;
+      this.descriptionTextBox.Text = "";
+      // 
+      // PluginView
+      // 
+      this.AutoScaleDimensions = new System.Drawing.SizeF(6F, 13F);
+      this.AutoScaleMode = System.Windows.Forms.AutoScaleMode.Font;
+      this.Controls.Add(this.descriptionTextBox);
+      this.Controls.Add(this.errorTextBox);
+      this.Controls.Add(this.errorLabel);
+      this.Controls.Add(this.descriptionLabel);
+      this.Controls.Add(this.stateTextBox);
+      this.Controls.Add(this.stateLabel);
+      this.Controls.Add(this.dependenciesGroupBox);
+      this.Controls.Add(this.filesGroupBox);
+      this.Controls.Add(this.licenseButton);
+      this.Controls.Add(this.contactTextBox);
+      this.Controls.Add(this.contactInfoLabel);
+      this.Controls.Add(this.versionTextBox);
+      this.Controls.Add(this.versionLabel);
+      this.Controls.Add(this.nameTextBox);
+      this.Controls.Add(this.nameLabel);
+      this.Name = "PluginView";
+      this.Size = new System.Drawing.Size(346, 612);
+      this.dependenciesGroupBox.ResumeLayout(false);
+      this.filesGroupBox.ResumeLayout(false);
+      this.ResumeLayout(false);
+      this.PerformLayout();
+
+    }
+
+    #endregion
+
+    protected System.Windows.Forms.Label nameLabel;
+    protected System.Windows.Forms.TextBox nameTextBox;
+    protected System.Windows.Forms.TextBox versionTextBox;
+    protected System.Windows.Forms.Label versionLabel;
+    protected System.Windows.Forms.TextBox contactTextBox;
+    protected System.Windows.Forms.Label contactInfoLabel;
+    protected System.Windows.Forms.Button licenseButton;
+    protected System.Windows.Forms.GroupBox dependenciesGroupBox;
+    private System.Windows.Forms.ColumnHeader pluginNameHeader;
+    private System.Windows.Forms.ColumnHeader pluginVersionHeader;
+    protected System.Windows.Forms.ListView dependenciesListView;
+    private System.Windows.Forms.ListView filesListView;
+    private System.Windows.Forms.GroupBox filesGroupBox;
+    private System.Windows.Forms.ImageList imageList;
+    private System.Windows.Forms.ColumnHeader fileNameHeader;
+    private System.Windows.Forms.ColumnHeader fileTypeHeader;
+    protected System.Windows.Forms.TextBox stateTextBox;
+    protected System.Windows.Forms.Label stateLabel;
+    protected System.Windows.Forms.Label errorLabel;
+    protected System.Windows.Forms.Label descriptionLabel;
+    private System.Windows.Forms.RichTextBox errorTextBox;
+    private System.Windows.Forms.RichTextBox descriptionTextBox;
+
+  }
+}
Index: trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginView.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginView.cs	(revision 3006)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Advanced/PluginView.cs	(revision 3006)
@@ -0,0 +1,93 @@
+﻿using System;
+using System.Collections.Generic;
+using System.ComponentModel;
+using System.Drawing;
+using System.Data;
+using System.Linq;
+using System.Text;
+using System.Windows.Forms;
+using HeuristicLab.PluginInfrastructure;
+using System.IO;
+using HeuristicLab.PluginInfrastructure.Manager;
+
+namespace HeuristicLab.PluginInfrastructure.Advanced {
+  internal partial class PluginView : InstallationManagerControl {
+    private const string IMAGE_KEY_ASSEMBLY = "Assembly";
+    private const string IMAGE_KEY_FILE = "File";
+    private const string IMAGE_KEY_DOCUMENT = "Document";
+
+    private PluginDescription plugin;
+
+    public PluginView() {
+      InitializeComponent();
+      PopulateImageList();
+    }
+
+    public PluginView(PluginDescription plugin) {
+      InitializeComponent();
+      PopulateImageList();
+
+      this.plugin = plugin;
+      this.Name = "Plugin Details: " + plugin.ToString();
+      UpdateControls();
+    }
+
+    private void PopulateImageList() {
+      imageList.Images.Add(IMAGE_KEY_ASSEMBLY, HeuristicLab.PluginInfrastructure.Resources.Resources.Assembly);
+      imageList.Images.Add(IMAGE_KEY_FILE, HeuristicLab.PluginInfrastructure.Resources.Resources.File);
+      imageList.Images.Add(IMAGE_KEY_DOCUMENT, HeuristicLab.PluginInfrastructure.Resources.Resources.Document);
+    }
+
+    public void UpdateControls() {
+      string appDir = Path.GetDirectoryName(Application.ExecutablePath);
+      nameTextBox.Text = plugin.Name;
+      versionTextBox.Text = plugin.Version.ToString();
+      contactTextBox.Text = CombineStrings(plugin.ContactName, plugin.ContactEmail);
+      descriptionTextBox.Text = plugin.Description;
+      stateTextBox.Text = plugin.PluginState.ToString();
+      errorTextBox.Text = plugin.LoadingErrorInformation;
+      foreach (PluginDescription dependency in plugin.Dependencies) {
+        var depItem = new ListViewItem(new string[] { dependency.Name, dependency.Version.ToString() });
+        depItem.Tag = dependency;
+        depItem.ImageKey = IMAGE_KEY_ASSEMBLY;
+        dependenciesListView.Items.Add(depItem);
+      }
+      foreach (var file in plugin.Files) {
+        string displayedFileName = file.Name.Replace(appDir, string.Empty);
+        displayedFileName = displayedFileName.TrimStart(Path.DirectorySeparatorChar);
+        var fileItem = new ListViewItem(new string[] { displayedFileName, file.Type.ToString() });
+        if (file.Type == PluginFileType.Assembly) {
+          fileItem.ImageKey = IMAGE_KEY_ASSEMBLY;
+        } else if (file.Type == PluginFileType.License) {
+          fileItem.ImageKey = IMAGE_KEY_DOCUMENT;
+        } else fileItem.ImageKey = IMAGE_KEY_FILE;
+        filesListView.Items.Add(fileItem);
+      }
+      licenseButton.Enabled = !string.IsNullOrEmpty(plugin.LicenseText);
+    }
+
+    private string CombineStrings(string a, string b) {
+      if (string.IsNullOrEmpty(a))
+        // a is empty
+        if (!string.IsNullOrEmpty(b)) return CombineStrings(b, string.Empty);
+        else return string.Empty;
+      // a is not empty
+      else if (string.IsNullOrEmpty(b)) return a;
+      // and b are not empty
+      else return a + ", " + b;
+    }
+
+    private void licenseButton_Click(object sender, EventArgs e) {
+      LicenseView view = new LicenseView(plugin);
+      view.ShowInForm();
+    }
+
+    private void dependenciesListView_ItemActivate(object sender, EventArgs e) {
+      if (dependenciesListView.SelectedItems.Count > 0) {
+        var dep = (PluginDescription)dependenciesListView.SelectedItems[0].Tag;
+        PluginView view = new PluginView(dep);
+        view.ShowInForm();
+      }
+    }
+  }
+}
Index: trunk/sources/HeuristicLab.PluginInfrastructure/HeuristicLab.PluginInfrastructure.csproj
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/HeuristicLab.PluginInfrastructure.csproj	(revision 3005)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/HeuristicLab.PluginInfrastructure.csproj	(revision 3006)
@@ -93,5 +93,13 @@
   </ItemGroup>
   <ItemGroup>
+    <Compile Include="Advanced\ConnectionSetupView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Advanced\ConnectionSetupView.Designer.cs">
+      <DependentUpon>ConnectionSetupView.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Advanced\DeploymentService\AdminClientFactory.cs" />
     <Compile Include="Advanced\DeploymentService\DeploymentService.cs" />
+    <Compile Include="Advanced\DeploymentService\UpdateClientFactory.cs" />
     <Compile Include="Advanced\InstallationManagerConsole.cs" />
     <Compile Include="Advanced\InstallationManager.cs" />
@@ -108,4 +116,16 @@
       <SubType>Code</SubType>
     </Compile>
+    <Compile Include="Advanced\LicenseConfirmationBox.cs">
+      <SubType>Form</SubType>
+    </Compile>
+    <Compile Include="Advanced\LicenseConfirmationBox.Designer.cs">
+      <DependentUpon>LicenseConfirmationBox.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Advanced\LicenseView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Advanced\LicenseView.Designer.cs">
+      <DependentUpon>LicenseView.cs</DependentUpon>
+    </Compile>
     <Compile Include="Advanced\LocalPluginManager.cs">
       <SubType>UserControl</SubType>
@@ -113,4 +133,16 @@
     <Compile Include="Advanced\LocalPluginManager.Designer.cs">
       <DependentUpon>LocalPluginManager.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Advanced\InstallationManagerControl.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Advanced\InstallationManagerControl.Designer.cs">
+      <DependentUpon>InstallationManagerControl.cs</DependentUpon>
+    </Compile>
+    <Compile Include="Advanced\PluginView.cs">
+      <SubType>UserControl</SubType>
+    </Compile>
+    <Compile Include="Advanced\PluginView.Designer.cs">
+      <DependentUpon>PluginView.cs</DependentUpon>
     </Compile>
     <Compile Include="Advanced\RemotePluginInstaller.cs">
@@ -221,7 +253,22 @@
     <Content Include="Resources\List.gif" />
     <Content Include="Resources\Logo_white.gif" />
+    <EmbeddedResource Include="Advanced\ConnectionSetupView.resx">
+      <DependentUpon>ConnectionSetupView.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="Advanced\DeploymentService\servdev.cer" />
+    <EmbeddedResource Include="Advanced\LicenseConfirmationBox.resx">
+      <DependentUpon>LicenseConfirmationBox.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="Advanced\LicenseView.resx">
+      <DependentUpon>LicenseView.cs</DependentUpon>
+    </EmbeddedResource>
+    <EmbeddedResource Include="Advanced\PluginView.resx">
+      <DependentUpon>PluginView.cs</DependentUpon>
+    </EmbeddedResource>
     <None Include="Resources\VS2008ImageLibrary_Actions_Delete.png" />
     <None Include="Resources\VS2008ImageLibrary_CommonElements_Actions_Remove.png" />
     <Content Include="Resources\VS2008ImageLibrary_CommonElements_Objects_Arrow_Down.png" />
+    <None Include="Resources\VS2008ImageLibrary_Objects_File.png" />
+    <None Include="Resources\VS2008ImageLibrary_Objects_Document.png" />
     <None Include="Resources\VS2008ImageLibrary_Objects_Internet.png" />
     <None Include="Resources\VS2008ImageLibrary_Objects_Install.png" />
Index: trunk/sources/HeuristicLab.PluginInfrastructure/Manager/PluginFile.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Manager/PluginFile.cs	(revision 3005)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Manager/PluginFile.cs	(revision 3006)
@@ -47,4 +47,8 @@
       this.type = type;
     }
+
+    public override string ToString() {
+      return name;
+    }
   }
 }
Index: trunk/sources/HeuristicLab.PluginInfrastructure/Manager/PluginInfrastructureCancelEventArgs.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Manager/PluginInfrastructureCancelEventArgs.cs	(revision 3005)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Manager/PluginInfrastructureCancelEventArgs.cs	(revision 3006)
@@ -29,8 +29,8 @@
   [Serializable]
   internal sealed class PluginInfrastructureCancelEventArgs : CancelEventArgs {
-    internal IEnumerable<string> Entities { get; private set; }
-    internal PluginInfrastructureCancelEventArgs(IEnumerable<string> entities)
+    internal IEnumerable<IPluginDescription> Plugins { get; private set; }
+    internal PluginInfrastructureCancelEventArgs(IEnumerable<IPluginDescription> plugins)
       : base() {
-      this.Entities = entities;
+      this.Plugins = plugins;
     }
   }
Index: trunk/sources/HeuristicLab.PluginInfrastructure/Properties/Settings.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Properties/Settings.Designer.cs	(revision 3005)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Properties/Settings.Designer.cs	(revision 3006)
@@ -42,12 +42,49 @@
         }
         
-        [global::System.Configuration.ApplicationScopedSettingAttribute()]
+        [global::System.Configuration.UserScopedSettingAttribute()]
         [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
-        [global::System.Configuration.DefaultSettingValueAttribute("<?xml version=\"1.0\" encoding=\"utf-16\"?>\r\n<ArrayOfString xmlns:xsi=\"http://www.w3." +
-            "org/2001/XMLSchema-instance\" xmlns:xsd=\"http://www.w3.org/2001/XMLSchema\">\r\n  <s" +
-            "tring>http://localhost:59253/UpdateLocation.svc</string>\r\n</ArrayOfString>")]
-        public global::System.Collections.Specialized.StringCollection UpdateLocations {
+        [global::System.Configuration.DefaultSettingValueAttribute("http://servdev.heuristiclab.com/Deployment/Update.svc")]
+        public string UpdateLocation {
             get {
-                return ((global::System.Collections.Specialized.StringCollection)(this["UpdateLocations"]));
+                return ((string)(this["UpdateLocation"]));
+            }
+            set {
+                this["UpdateLocation"] = value;
+            }
+        }
+        
+        [global::System.Configuration.UserScopedSettingAttribute()]
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.Configuration.DefaultSettingValueAttribute("")]
+        public string UpdateLocationUserName {
+            get {
+                return ((string)(this["UpdateLocationUserName"]));
+            }
+            set {
+                this["UpdateLocationUserName"] = value;
+            }
+        }
+        
+        [global::System.Configuration.UserScopedSettingAttribute()]
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.Configuration.DefaultSettingValueAttribute("")]
+        public string UpdateLocationPassword {
+            get {
+                return ((string)(this["UpdateLocationPassword"]));
+            }
+            set {
+                this["UpdateLocationPassword"] = value;
+            }
+        }
+        
+        [global::System.Configuration.UserScopedSettingAttribute()]
+        [global::System.Diagnostics.DebuggerNonUserCodeAttribute()]
+        [global::System.Configuration.DefaultSettingValueAttribute("http://servdev.heuristiclab.com/Deployment/Admin.svc")]
+        public string UpdateLocationAdministrationAddress {
+            get {
+                return ((string)(this["UpdateLocationAdministrationAddress"]));
+            }
+            set {
+                this["UpdateLocationAdministrationAddress"] = value;
             }
         }
Index: trunk/sources/HeuristicLab.PluginInfrastructure/Properties/Settings.settings
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Properties/Settings.settings	(revision 3005)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Properties/Settings.settings	(revision 3006)
@@ -9,9 +9,15 @@
       <Value Profile="(Default)">-</Value>
     </Setting>
-    <Setting Name="UpdateLocations" Type="System.Collections.Specialized.StringCollection" Scope="Application">
-      <Value Profile="(Default)">&lt;?xml version="1.0" encoding="utf-16"?&gt;
-&lt;ArrayOfString xmlns:xsi="http://www.w3.org/2001/XMLSchema-instance" xmlns:xsd="http://www.w3.org/2001/XMLSchema"&gt;
-  &lt;string&gt;http://localhost:59253/UpdateLocation.svc&lt;/string&gt;
-&lt;/ArrayOfString&gt;</Value>
+    <Setting Name="UpdateLocation" Type="System.String" Scope="User">
+      <Value Profile="(Default)">http://servdev.heuristiclab.com/Deployment/Update.svc</Value>
+    </Setting>
+    <Setting Name="UpdateLocationUserName" Type="System.String" Scope="User">
+      <Value Profile="(Default)" />
+    </Setting>
+    <Setting Name="UpdateLocationPassword" Type="System.String" Scope="User">
+      <Value Profile="(Default)" />
+    </Setting>
+    <Setting Name="UpdateLocationAdministrationAddress" Type="System.String" Scope="User">
+      <Value Profile="(Default)">http://servdev.heuristiclab.com/Deployment/Admin.svc</Value>
     </Setting>
   </Settings>
Index: trunk/sources/HeuristicLab.PluginInfrastructure/Resources/Resources.Designer.cs
===================================================================
--- trunk/sources/HeuristicLab.PluginInfrastructure/Resources/Resources.Designer.cs	(revision 3005)
+++ trunk/sources/HeuristicLab.PluginInfrastructure/Resources/Resources.Designer.cs	(revision 3006)
@@ -75,4 +75,18 @@
         }
         
+        internal static System.Drawing.Bitmap Document {
+            get {
+                object obj = ResourceManager.GetObject("Document", resourceCulture);
+                return ((System.Drawing.Bitmap)(obj));
+            }
+        }
+        
+        internal static System.Drawing.Bitmap File {
+            get {
+                object obj = ResourceManager.GetObject("File", resourceCulture);
+                return ((System.Drawing.Bitmap)(obj));
+            }
+        }
+        
         internal static System.Drawing.Bitmap Install {
             get {
